%christmas
% Function which solves the Nth days of Christmas problem.
% i.e. on the first day of Christmas you get 1 present
% on the second day you get 1 + 2 presents
% on the third day you get 1 + 2 + 3 presents etc
%
% There is actually a formula for the total number of presents
% which is rather pleasingly N*(N+1)*(N+2)/6
%
% LAST UPDATED by Andy French April 2016

function christmas

%Display message to command window
disp(' ')
disp(' %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%' )
disp('  Festive Greetings! The N days of Christmas has begun.... ')
disp(' %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%' )
disp(' ')

%Request number of days from user. 
% Set default of 12 if nothing is stated and the return key is pressed.
N = input(' How many days of Christmas? N = ');
if isempty(N)
    N = 12;
    disp(' Default of N = 12 chosen.')
end

%Initialize number of presents received.
s = 0;

%Loop over N days to work out total number of presents
for n=1:N
    %On day n you will receive 1 + 2 + 3 + ... n presents
    %So we will need another loop (unles we use the formula 0.5*n(n+1) for
    %the sum of the first n integers!)
    for m=1:n
        s = s + m;
    end
end

%Display total number of presents received
disp(' ')
disp([' Congratulations! You will receive a total of ',num2str(s),' presents!'])

%Check calculation by application of the sum formula
s_check = (1/6)*N*(N+1)*(N+2);
disp(' ')
if s-s_check == 0
    disp(' Loop calculation agrees with formula s = (1/6)*N*(N+1)*(N+2)')
else
    disp(' Loop calculation does not agree with formula s = (1/6)*N*(N+1)*(N+2)')
end
disp(' ');

%End of code